<!doctype html>
<html lang="en">

<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
  <meta name="description" content="">
  <meta name="authors" content="Bo Zhao, Fengyu Xu, Lola Kang, Joshua Ji, and Steven Bao">
  <!-- <meta http-equiv="Cache-Control" content="no-cache, no-store, must-revalidate" />
  <meta http-equiv="Pragma" content="no-cache" />
  <meta http-equiv="Expires" content="0" /> -->
  <title>Verbreitung des neuartigem Coronavirus</title>
  <link rel="stylesheet" href="css/bootstrap.min.css">
  <link rel="stylesheet" href="css/leaflet.css" />
  <link rel="stylesheet" href="css/MarkerCluster.Default.css">
  <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.8.1/css/all.css">
  <link href="https://fonts.googleapis.com/css?family=Titillium+Web|Oswald" rel="stylesheet">
  <link href="css/c3.min.css" rel="stylesheet">
  <link rel="stylesheet" href="css/simplebar.css" />
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/animate.css/3.7.2/animate.min.css">
  <link href="css/bootstrap4-toggle.min.css" rel="stylesheet">
  <link rel="stylesheet" href="css/main.css">
  <link rel="stylesheet" href="css/mobile.css">
  <link rel="icon" href="img/favicon.ico" type="image/x-icon">
  <script src="js/d3.js"></script>
  <script src="js/c3.min.js"></script>
  <script src="js/leaflet.js"></script>
  <script src="js/leaflet.markercluster.js"></script>
  <script src="js/leaflet-polygon.fillPattern.js"></script>
  <script src="js/topojson.v1.min.js"></script>
  <script src="js/chroma.min.js"></script>
  <script src="js/jquery-3.3.1.min.js"></script>
  <script type="text/javascript" src="js/jquery.sparkline.min.js"></script>
  <script src="js/bootstrap.min.js"></script>
  <script src="js/bootstrap4-toggle.min.js"></script>
  <script src="js/simplebar.min.js"></script>
</head>

<body>
  <main>
    <div class="loader"></div>
    <div id="mobiledeck">
      <p>
        <span class="mobile-title">Bestätigte Fälle gesamt</span>
        <span class="confirmed-count"></span>
        <span class="confirmed-new-count "></span>
        <p>
          <p>
            <span class="mobile-title">Bestätigte Fälle aktiv</span>
            <span class="active-count"></span>
            <span class="active-new-count"></span>
            <p>

              <p>
                <span class="mobile-title">Genesen</span>
                <span class="recovered-count"></span>
                <span class="recovered-new-count"></span>
                <p>

                  <p>
                    <span class="mobile-title">Tote</span>
                    <span class="death-count"></span>
                    <span class="death-new-count"></span>
                    <p>
    </div>

    <div id="info" data-simplebar data-simplebar-auto-hide="true">
      <div id="title" style="font-size:19px"><img src="img/virus_logo.png" width="28px"> Verbreitung des neuartigen Coronavirus (COVID-19)
      <span><p align="right" style="margin-right:5px; margin-top:-15px"><a href="https://wirvsvirushackathon.org/" target="_blank"><img src="img/Hackathon_slogan_weiß.png" width="130px"></img></a></p><span>

        <span><a href="https://gitlab.com/jdcoding/explore-corona" target="_blank"><i class="fab fa-gitlab"></i></a></span>
        <span><a href="https://github.com/jakobzhao/virus" target="_blank"><i class="fab fa-github-square"></i></a></span>
        <span><a data-toggle="modal" data-target="#resourcewindow"><i class="far fa-newspaper"></i></a></span>
        <span><a data-toggle="modal" data-target="#infowindow"><i class="nav fas fa-question-circle"></i></a></span>
      </div>

      <p><span id="placename">WELTWEITER TREND</span> </p>
      <div><span id="last-date">Letztes Update:</span><span id="date"></span> <span id="hint"> Klicken sie auf einen Ort um den dortigen Trend anzuzeigen.</span></div>
      <div id="deck-1" class="card-deck counts">
        <div class="card">
          <div class="card-body confirmed">
            <h5 class="card-title">Bestätigte Fälle gesamt
              <i class="nav fas fa-exclamation-circle tooltip">
                <span class="tooltiptext">Alle bestätigten Fälle seit Entdeckung von COVID-19 in dem ausgewählten Gebiet.</span>
              </i>
            </h5>
          </div>
          <p class="card-text">
            <span class="confirmed-count"></span><span class="confirmed-new-count">
            </span>
          </p>
        </div>
        <div class="card">
          <div class="card-body active">
            <h5 class="card-title">Aktive Fälle
              <i class="nav fas fa-exclamation-circle tooltip">
                <span class="tooltiptext">Übrige bestätigte Fälle. Die Genesenen und Toten sind hier nicht eingeschlossen.</span>
              </i>
            </h5>
          </div>
          <p class="card-text">
            <span class="active-count"></span>
            <span class="active-new-count"></span>
            <i id="counticon" class="nav fas fa-exclamation-circle tooltip counticon active-new-count-tooltip">
              <span class="tooltiptext">Der Neuzuwachs/Abnahme an bestätigten Fällen. Die Anzahl heutiger aktiver Fälle minus der Zahl am Vortag.</span>
            </i>

          </p>
        </div>
      </div>
      <div id="deck-2" class="card-deck counts">
        <div class="card">
          <div class="card-body recovered">
            <h5 class="card-title">Genesen</h5>
            <p class="card-text"><span class="recovered-count"></span><span class="recovered-new-count"></span></p>
          </div>
        </div>

        <div class="card">
          <div class="card-body death">
            <h5 class="card-title">Tote</h5>
            <p class="card-text"><span class="death-count"></span><span class="death-new-count"></span></p>
          </div>
        </div>
      </div>

      <div>Bisherige Fälle</div>
      <div id="total-chart"></div>
      <div>Vorhersage</div>
      <div id="prediction-chart"></div>

      <div id="footer">
        <div id="mtToggle">
          <span id="rankingText"> <b>Sortierung Welt oder Deutschland</b> </span>
          <!-- #e8e3d3; -->
          <!-- #dc3545; -->
          <span id="rankingIcon"><i style="margin-left:10px;color:#dc3545;" class="fas fa-angle-double-right animated infinite slideInLeft delay-2s" style="gray"></i></span>
          <span id="rankingSpace" style="margin-right:1px"> </span>
          <input type="checkbox" id="panelSwitcher" unchecked data-toggle="toggle" data-off="Situational Heatmap" data-width="180" data-size="xs" data-on="Back to Map" data-onstyle="secondary" data-offstyle="outline-secondary">
          <span style="margin-right:25px"> </span>
          <span id="rankingToggle"><input type="checkbox" id="areaSwitcher" unchecked data-toggle="toggle" data-on="Global Rank" data-width="100" data-size="xs" data-off="DE Rank" data-onstyle="secondary" data-offstyle="outline-secondary">
          </span>
        </div>

        <div id="content-explain" style="margin-top:30px">  Auf der Weltkarte sind die Infektionen (Anzahl der aktuellen aktiven bestätigten Fälle) in einer Region oder einem Land farblich dargestellt. Länder und Regionen ohne vorherige bestätigte Fälle werden grau schraffiert dargestellt. In den grün schraffierten Gebieten ist die Zahl der aktiven Fälle wieder auf 0 zurückgegangen.</div>

        <div>Daten über die weltweiten Fallzahlen werden von der <a href="https://github.com/CSSEGISandData/COVID-19"> John Hopkins University</a> bezogen. Die Daten zur Lage innerhalb Deutschlands stammen vom <a href="https://www.rki.de/DE/Content/InfAZ/N/Neuartiges_Coronavirus/Fallzahlen.html" target="_blank">Robert Koch-Institut</a>.
            </div>
          <div>
        Diese Interaktive Karte wurde im Rahmen des <a href="https://wirvsvirushackathon.org/"> <b>WirVsVirus Hackathon</b></a> basierend auf einer Karte des <a href="http://hgis.uw.edu" target="_blank">Humanistic GIS Lab at University of Washington - Seattle</a> erstellt (Originalversion von Bo Zhao, Fengyu Xu, Lola Kang, Joshua Ji und Steven Bao). <a href="https://github.com/jakobzhao/virus"> Weitere Informationen zu diesem Projekt finden sie hier.</a> Beteiligt an der Entwicklung waren: Matthias Zipper, Alexander Christoph, Rachel Korn, Jonathan list, Ariane Ziehn und Johannes Döllinger

    <div> <font size="1"><b>Impressum:</b> Johannes Döllinger, Zwerchstr. 6, 71229 Leonberg, Germany<br /> </div>

            
            <!--This map is made by the <a href="http://hgis.uw.edu" target="_blank">Humanistic GIS Lab at University of Washington - Seattle</a>.
          The data are mainly collected from <a href="https://www.who.int/emergencies/diseases/novel-coronavirus-2019/situation-reports/" target="_blank">WHO</a>,
          <a href="https://www.cdc.gov/coronavirus/2019-ncov/cases-in-us.html" target="_blank">CDC</a>,
          <a href="https://www.canada.ca/en/public-health/services/diseases/2019-novel-coronavirus-infection.html" target="_blank">PHA</a> ,
          <a href="http://2019ncov.chinacdc.cn/2019-nCoV/" target="_blank">China CDC</a>,
          <a href="https://www.nbcnews.com/health/health-news/coronavirus-u-s-map-where-virus-has-been-confirmed-across-n1124546" target="_blank">NBC News</a>,
          and <a href="https://voice.baidu.com/act/newpneumonia/newpneumonia" target="_blank">Baidu</a>. Regarding the state level data in the U.S., they are collected from CDC, state officials and <a
            href="https://www.nbcnews.com/health/health-news/coronavirus-u-s-map-where-virus-has-been-confirmed-across-n1124546" target="_blank">NBC News</a>.
          The computational resources are provided by <a href="https://csde.washington.edu/" target="_blank">UW's Center for Studies in Demography and Ecology</a>. The base maps are from <a target="_blank"
            href="https://github.com/CartoDB/cartodb/wiki/BaseMaps-available">Carto</a> and <a href="https://server.arcgisonline.com/ArcGIS/rest/services/World_Imagery/MapServer/" target="_blank">ESRI</a>, and the geospatial data for the base maps
          are acquired from the <a href="openstreetmap.org/copyright" target="_blank"> OpenStreetMap</a>.
          <span class="emphasis">The timely updated dataset of the virus infection can be downloaded <a href="http://hgis.uw.edu/virus/assets/virus.csv" target="_blank">here.</a></span> Details
          about this interactive
          map can be found <a data-toggle="modal" data-target="#infowindow"> here</a>. If you have any questions or
          concerns, please contact <a href="mailto:zhaobo@uw.edu">Bo Zhao</a>. -->

         <div align="right" style="margin-right:25px">
        <b>Supported by</b>
         </div>
        </div>

        <p align="right" style="margin-right:25px; margin-top:-8px"><a href="https://hgis.uw.edu/2020/03/18/covid-19-novel-coronavirus-infection-map/" target="_blank"><img src="img/logo.png" width="130px"></img></a></p>

      </div>


    </div>
    <div id="table">
      <div id="table-container" data-simplebar data-simplebar-auto-hide="true">
        <table id="table-container-div" class="table table-bordered table-fixed table-hover">
          <thead>
          </thead>
          <tbody>
          </tbody>
        </table>
      </div>
    </div>

    <div id="legend-panel" class="card-deck legend">

      <div class="card">
        <div class="card-body">
          <h5 class="card-title grey-circles" style="color:black">no case</h5>
        </div>
      </div>

      <div class="card">
        <div class="card-body legend-color-1">
          <h5 class="card-title" style="color:black">1</h5>

        </div>
      </div>

      <div class="card">
        <div class="card-body legend-color-2">
          <h5 class="card-title" style="color:black">10</h5>

        </div>
      </div>
      <div class="card">
        <div class="card-body  legend-color-3">
          <h5 class="card-title" style="color:black">100</h5>

        </div>
      </div>

      <div class="card">
        <div class="card-body  legend-color-4">
          <h5 class="card-title" style="color:black">250</h5>

        </div>
      </div>

      <div class="card">
        <div class="card-body legend-color-5">
          <h5 class="card-title" style="color:black">1,000</h5>
        </div>
      </div>

      <div class="card">
        <div class="card-body legend-color-6">
          <h5 class="card-title" style="color:black">10,000+</h5>
        </div>
      </div>
    </div>
    <div id="map"></div>


  </main>
  <div id="infowindow" class="modal fade" tabindex="-1" role="dialog" aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
    <div class="modal-dialog modal-dialog-centered" role="document" style="width:1250px!important">
      <div class="modal-content">
        <div class="modal-header">
          <strong class="modal-title" id="exampleModalLongTitle">Info</strong>
          <button type="button" class="close" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <div class="modal-body">
          <div id="demo" class="carousel " data-ride="carousel">

              <h5>SIR-Modellierung</h5>
             <h5>Interaktive Karte</h5>
              <p>Diese interaktive Karte ermöglicht es Nutzern, globale und regionale Entwicklungen der Infektionen mit dem neuartigen Coronavirus (COVID-19) seit dem 21. Januar 2020 darzustellen. Die in dieser Karte dargestellten Daten stammen aus verschiedenen offiziellen Quellen. </p>
             <!--<h5>Qellen</h5>
            <p>Die Daten stammen primär von 1. <a href="http://www.nhc.gov.cn" target="_blank">Nationale Gesundheiskommission</a> (NHC) der Volksrepublik China
              2. Chinesische provinzielle & stätischen Gesundheitskommissionen, Datenbank der chinesischen provinziellen & städtischen Verwaltung
              3. Öffentlich zugängliche Datensätze aus Hongkong, Macau, und Taiwan
              4. <a href="https://www.who.int/emergencies/diseases/novel-coronavirus-2019/situation-reports/" target="_blank">World Health Organization</a> (WHO)
              5. <a href="https://www.cdc.gov/coronavirus/2019-ncov/cases-in-us.html" target="_blank">Centers for Disease Control and Prevention</a> (CDC)
              6. <a href="https://www.canada.ca/en/public-health/services/diseases/2019-novel-coronavirus-infection.html" target="_blank">Public Health Agency of Canada</a> (PHAC)

              7. <a href="https://voice.baidu.com/act/newpneumonia/newpneumonia" target="_blank">Baidu</a>.
              8. <a href="https://lab.ahusmart.com/nCoV/api/detail" target="_blank">ahusmart</a> - Die infizierten Gemeinden in China.
              9. Staatliche Stellen der US Bundesstaaten.
              10. <a href="https://www.nbcnews.com/health/health-news/coronavirus-u-s-map-where-virus-has-been-confirmed-across-n1124546" target="_blank">NBC News</a>.

              Der Datensatz steht online zur Verfügung, <a href="http://hgis.uw.edu/virus/assets/virus.db" target="_blank">im SQLite Format</a> und <a href="http://hgis.uw.edu/virus/assets/virus.csv" target="_blank">CSV format</a>.</p>


            <p>In der Tabelle gibt jeder Eintrag den Infektionsstatus im Format "#-#-#-#" an – Vier durch Striche geteilte Zahlen. Die erste Zahl entspricht den bestätigten Fällen, die zweite Zahl den Verdachtsfälle, die dritte den geheilten Fällen, die vierte Zahl den Todesfällen.</p>>-->


             <h5>SIR-Modell zur Visulisierung der Ausbreitung von COVID-19</h5>
            <p>Das <a href="https://de.wikipedia.org/wiki/SIR-Modell" target="_blank">Susceptible-Infected-Removed-Modell</a> (SIR-Modell)  ist ein mathematisches Modell, welches die Ausbreitung von ansteckenden Krankheiten, wie COVID-19, mit Immunitätsbildung darstellt. S, I und R sind Abkürzungen für die drei Stadien, die Menschen während der Immunitätsbildung durchlaufen: </p>
            <p>
              <li>Susceptible: Nicht Infizierte</li>
              <li>Infected: Infizierte</li>
              <li>Removed: Genese und Verstorbene</li>
              <!--<li>The Server is hosted at UW’s <a href="https://https://csde.washington.edu/" target="_blank">Center for Studies in Demography and Ecology (CSDE)</a>.</li>-->
            </p>
            <p>Während der Ausbreitung verändern sich die Gruppen. Zu Beginn (t0) befindet sich die gesamte Bevölkerung in der Gruppe S. Täglich (t1, t2, etc.) werden Infizierte gemeldet und von S nach I oder von I nach R verschoben. Unser Modell passt sich jeweils an die ausgewählte Region an. Des weiteren berechnet es den potenziellen Immunitätsbildungsprozess abhängig von der Ansteckungsrate und den aktuellen Daten.</p>

            <!--h5>Update Prozedur</h5--->

            <!--<p>Die Daten auf Länderebene werden von der WHO bezogen, während die Daten jeder Provinz in China aus verschiedenen Quellen wie NHC, Mapmiao und Baidu gesammelt werden. Insbesondere um den Status der Virusverbreitung in den USA zu überprüfen werden Daten des CDC verwendet. Die Daten werden alle 4 Stunden aktualisiert und die Datenqualität regelmäßig überprüft. Darüber hinaus ist die Bereitstellung von höher aufgelösten Daten aus China (auf Kreisebene), den USA (auf Ebene der Bundesstaaten) und Kanada (auf Ebene der Provinzen) in der nächsten Version geplant.</p>

            <h5>Acknowledgment</h5>-->
            <p>
              <!--<li>The Server is hosted at UW’s <a href="https://https://csde.washington.edu/" target="_blank">Center for Studies in Demography and Ecology (CSDE)</a>.</li>-->
            </p>
          </div>
        </div>
      </div>
    </div>
  </div>
  <div id="resourcewindow" class="modal fade" tabindex="-1" role="dialog" aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
    <div class="modal-dialog modal-dialog-centered" role="document" style="width:1250px!important">
      <div class="modal-content">
        <div class="modal-header">
          <strong class="modal-title" id="exampleModalLongTitle">Resource</strong>
          <button type="button" class="close" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <div class="modal-body">
          <div id="demo" class="carousel " data-ride="carousel">
            <h5>Coronavirus Informationsquellen</h5>
            <br><b>Hauptinformationsquellen:</b>
            <ul>
              <li><a href="https://github.com/CSSEGISandData/COVID-19" target="_blank"> John Hopkins University</a></li>
              <li><a href="https://www.rki.de/DE/Content/InfAZ/N/Neuartiges_Coronavirus/Fallzahlen.html" target="_blank"> Robert Koch-Institut</a></li>
            </ul>
            <br><b> Offizielle Homepages China</b>
            <table style="width:100%">
              <tr>
                <td><a href="http://wjw.beijing.gov.cn/xwzx_20031/wnxw/" target="_blank"> Beijing</a></td>
                <td><a href="http://wsjkw.hebei.gov.cn/list/more_newlist_14.html" target="_blank"> Hebei</a></td>
                <td><a href="http://wsjk.ln.gov.cn/wst_zdzt/xxgzbd/yqtb/" target="_blank"> Liaoning</a></td>
                <td><a href=" http://www.jl.gov.cn/szfzt/jlzxd/yqtb/" target="_blank"> Jilin</a></td>
              </tr>
              <tr>
                <td><a href="http://wjw.jiangsu.gov.cn/col/col7290/index.html" target="_blank"> Jiangsu</a></td>
                <td><a href="http://wsjkw.sh.gov.cn/yqfk2020/" target="_blank"> Shanghai</a></td>
                <td><a href="http://hc.jiangxi.gov.cn/ztxx/xxgzbdgrdfyyqfk/yqtb/index.shtml" target="_blank"> Jiangxi</a></td>
                <td><a href="http://wsjkw.gd.gov.cn/zwyw_yqxx/" target="_blank"> Guangdong</a></td>
              </tr>
              <tr>
                <td><a href="http://wjw.hunan.gov.cn/wjw/qwfb/yqfkgz_list.html" target="_blank"> Hunan</a></td>
                <td><a href="http://wst.hainan.gov.cn/yqfk/" target="_blank"> Hainan</a></td>
                <td><a href="https://www.zjwjw.gov.cn/col/col1202112/index.html" target="_blank"> Zhejiang</a></td>
                <td><a href="http://www.hnwsjsw.gov.cn/channels/854.shtml" target="_blank"> Henan</a></td>
              </tr>
              <tr>
                <td><a href="http://hc.jiangxi.gov.cn/ztxx/xxgzbdgrdfyyqfk/yqtb/index.shtml" target="_blank"> Jiangxi</a></td>
                <td><a href="http://wjw.hubei.gov.cn/bmdt/ztzl/fkxxgzbdgrfyyq/xxfb/" target="_blank"> Hubei</a></td>
                <td><a href=" http://sxwjw.shaanxi.gov.cn/col/col9/index.html" target="_blank"> Shaanxi</a></td>
                <td><a href="http://wjw.shanxi.gov.cn/wjywl02/index.hrh" target="_blank"> Shanxi</a></td>
              </tr>
              <tr>
                <td><a href="http://wsjkw.nx.gov.cn/yqfkdt/yqsd1.htm" target="_blank"> Ningxia</a></td>
                <td><a href="https://wsjkw.qinghai.gov.cn/ztbd/yqjk/fkdt/2020/02/18/1582009147575.html" target="_blank"> Qinghai</a></td>
                <td><a href="http://wsjk.gansu.gov.cn/channel/11217/index.html" target="_blank"> Gansu</a></td>
                <td><a href="http://xjhfpc.gov.cn/ztzl/fkxxgzbdfygz/yqtb.htm" target="_blank"> Xinjiang</a></td>
              </tr>
              <tr>
                <td><a href="http://www.gzhfpc.gov.cn/ztzl_500663/xxgzbdgrdfyyqfk/" target="_blank"> Guizhou</a></td>
                <td><a href="http://ynswsjkw.yn.gov.cn/wjwWebsite/web/col?id=UU157976428326282067&cn=xxgzbd&pcn=ztlm&pid=UU145102906505319731" target="_blank"> Yunnan</a></td>
                <td><a href="http://wsjkw.cq.gov.cn/topic/25.jspx" target="_blank"> Chongqing</a></td>
                <td><a href="http://wjw.xizang.gov.cn/xwzx/wsjkdt/" target="_blank"> Xizang</a></td>
              </tr>
              <tr>
                <td><a href="https://www.ssm.gov.mo/apps1/PreventWuhanInfection/ch.aspx#clg17046" target="_blank"> Macau</a></td>
                <td><a href="https://sites.google.com/cdc.gov.tw/2019ncov/taiwan" target="_blank"> Taiwan</a></td>
                <td><a href="http://wsjkw.hlj.gov.cn/index.php/Home/Zwgk/all/typeid/42" target="_blank"> Heilongjiang</a></td>
                <td><a href="https://v.gxnews.com.cn/zt/2020yq" target="_blank"> Guangxi</a></td>
              </tr>
              <tr>
                <td><a href="http://wjw.ah.gov.cn/news_list_477_1.html" target="_blank"> Anhui</a></td>
                <td><a href="http://wjw.nmg.gov.cn/xwzx/xwfb/index.shtml" target="_blank"> Neimenggu</a></td>
                <td><a href="http://wsjkw.sc.gov.cn/scwsjkw/gzbd01/ztwzlmgl.shtml" target="_blank"> Sichuan</a></td>
                <td><a href="https://www.chp.gov.hk/files/pdf/enhanced_sur_pneumonia_wuhan_chi.pdf" target="_blank"> Hongkong</a></td>
              </tr>
            </table>
            <br><b> Offizielle Homepages USA</b>
            <table style="width:100%">
              <tr>
                <td><a href="http://www.alabamapublichealth.gov/infectiousdiseases/2019-coronavirus.html" target="_blank">Alabama</a></td>
                <td><a href="https://dphhs.mt.gov/publichealth/cdepi/diseases/coronavirusmt" target="_blank">Montana</a></td>
                <td><a href="http://dhss.alaska.gov/dph/Epi/id/Pages/COVID-19/monitoring.aspx" target="_blank">Alaska</a></td>
                <td><a href="http://dhhs.ne.gov/Pages/Coronavirus.aspx" target="_blank">Nebraska</a></td>
              </tr>
              <tr>
                <td><a href="https://www.azdhs.gov/preparedness/epidemiology-disease-control/infectious-disease-epidemiology/index.php#novel-coronavirus-home" target="_blank">Arizona</a></td>
                <td><a href="http://dpbh.nv.gov/Programs/OPHIE/dta/Hot_Topics/Coronavirus/" target="_blank">Nevada</a></td>
                <td><a href="https://www.healthy.arkansas.gov/programs-services/topics/novel-coronavirus" target="_blank">Arkansas</a></td>
                <td><a href="https://www.dhhs.nh.gov/dphs/cdcs/2019-ncov.htm" target="_blank">New Hampshire</a></td>
              </tr>
              <tr>
                <td><a href="https://www.cdph.ca.gov/Programs/CID/DCDC/Pages/Immunization/ncov2019.aspx" target="_blank">California</a></td>
                <td><a href=" https://www.colorado.gov/pacific/cdphe/2019-novel-coronavirus" target="_blank">Colorado</a></td>
                <td><a href="https://cv.nmhealth.org/" target="_blank">New Mexico</a></td>
                <td><a href=" https://portal.ct.gov/coronavirus" target="_blank">Connecticut</a></td>
              </tr>
              <tr>
                <td><a href=" https://health.ny.gov/diseases/communicable/coronavirus/" target="_blank">New York</a></td>
                <td><a href="https://www.dhss.delaware.gov/dhss/dph/epi/2019novelcoronavirus.html" target="_blank">Delaware</a></td>
                <td><a href="https://coronavirus.dc.gov/page/coronavirus-surveillance-data" target="_blank">The District of Columbia</a></td>
                <td><a href="https://www.health.nd.gov/diseases-conditions/coronavirus/north-dakota-coronavirus-cases" target="_blank">North Dakota</a></td>
              </tr>
              <tr>
                <td><a href="http://www.floridahealth.gov/diseases-and-conditions/COVID-19/index.html" target="_blank">Florida</a></td>
                <td><a href="https://coronavirus.ohio.gov/wps/portal/gov/covid-19/" target="_blank">Ohio</a></td>
                <td><a href="https://dph.georgia.gov/" target="_blank">Georgia</a></td>
                <td><a href="https://www.ok.gov/health/Prevention_and_Preparedness/Acute_Disease_Service/Disease_Information/Coronavirus_Disease_2019/Oklahoma_Response_to_Coronavirus_Disease_2019/index.html" target="_blank">Oklahoma</a></td>
              </tr>
              <tr>
                <td><a href="https://www.oregon.gov/oha/PH/DISEASESCONDITIONS/DISEASESAZ/Pages/emerging-respiratory-infections.aspx" target="_blank">Oregon</a></td>
                <td><a href="https://health.hawaii.gov/docd/advisories/novel-coronavirus-2019/#situation" target="_blank">Hawaii</a></td>
                <td><a href="https://coronavirus.idaho.gov/" target="_blank">Idaho</a></td>
                <td><a href="https://www.health.pa.gov/topics/disease/Pages/Coronavirus.aspx" target="_blank">Pennsylvania</a></td>
              </tr>
              <tr>
                <td><a href="http://dph.illinois.gov/topics-services/diseases-and-conditions/diseases-a-z-list/coronavirus" target="_blank">Illinois</a></td>
                <td><a href="https://www.scdhec.gov/index.php/health/infectious-diseases/viruses/coronavirus-disease-2019-covid-19" target="_blank">South Carolina</a></td>
                <td><a href="https://idph.iowa.gov/Emerging-Health-Issues/Novel-Coronavirus" target="_blank">Iowa</a></td>
                <td><a href="https://doh.sd.gov/news/Coronavirus.aspx" target="_blank">South Dakota</a></td>
              </tr>
              <tr>
                <td><a href="https://chfs.ky.gov/agencies/dph/pages/covid19.aspx" target="_blank">Kentucky</a></td>
                <td><a href="https://www.dshs.state.tx.us/coronavirus/#casecounts" target="_blank">Texas</a></td>
                <td><a href="https://coronavirus.utah.gov/coronavirus-latest-information/" target="_blank">Utah</a></td>
                <td><a href="https://www.maine.gov/dhhs/mecdc/infectious-disease/epi/airborne/coronavirus.shtml" target="_blank">Maine</a></td>
              </tr>
              <tr>
                <td><a href="https://www.healthvermont.gov/response/infectious-disease/2019-novel-coronavirus" target="_blank">Vermont</a></td>
                <td><a href="https://phpa.health.maryland.gov/Pages/Novel-coronavirus.aspx" target="_blank">Maryland</a></td>
                <td><a href="http://www.vdh.virginia.gov/surveillance-and-investigation/novel-coronavirus/" target="_blank">Virginia</a></td>
                <td><a href="https://www.mass.gov/info-details/covid-19-cases-quarantine-and-monitoring" target="_blank">Massachusetts</a></td>
              </tr>
              <tr>
                <td><a href="https://www.doh.wa.gov/Emergencies/Coronavirus" target="_blank">Washington</a></td>
                <td><a href="https://www.michigan.gov/coronavirus" target="_blank">Michigan</a></td>
                <td><a href=" https://dhhr.wv.gov/Coronavirus%20Disease-COVID-19/Pages/default.aspx" target="_blank">West Virginia</a></td>
                <td><a href="https://www.health.state.mn.us/diseases/coronavirus/situation.html" target="_blank">Minnesota</a></td>
              </tr>
              <tr>
                <td><a href="https://www.dhs.wisconsin.gov/outbreaks/index.htm" target="_blank">Wisconsin</a></td>
                <td><a href=" https://msdh.ms.gov/msdhsite/_static/14,0,420.html" target="_blank">Mississippi</a></td>
                <td><a href="https://health.wyo.gov/publichealth/infectious-disease-epidemiology-unit/disease/novel-coronavirus/" target="_blank">Wyoming</a></td>
                <td><a href="https://health.mo.gov/living/healthcondiseases/communicable/novel-coronavirus/" target="_blank">Missouri</a></td>
              </tr>
            </table>
            <br><b>Offizielle Homepages anderer Länder</b>
            <table style="width:100%">
              <tr>
                <td><a href="https://www.cdc.gov/coronavirus/2019-ncov/cases-in-us.html" target="_blank"> the U.S.</a></td>
                <td><a href=" https://www.canada.ca/en/public-health/services/diseases/2019-novel-coronavirus-infection.html" target="_blank"> Canada</a></td>
                <td><a href="https://www.cdc.go.kr/board/board.es?mid=a20501000000&bid=0015" target="_blank"> Republic of Korean</a></td>
              </tr>
              <tr>
                <td><a href="https://www.mhlw.go.jp/stf/newpage_09571.html" target="_blank"> Japan</a></td>
                <td><a href="https://www.health.gov.au/news/health-alerts/novel-coronavirus-2019-ncov-health-alert#current-status" target="_blank"> Australia</a></td>
                <td><a href="https://www.moh.gov.sg/covid-19" target="_blank"> Singapore</a></td>
              </tr>
              <tr>
                <td><a href="http://www.salute.gov.it/nuovocoronavirus" target="_blank"> Italy</a></td>
                <td><a href="https://www.gov.uk/guidance/coronavirus-covid-19-information-for-the-public" target="_blank"> the UK</a></td>
                <td><a href="http://irangov.ir/cat/509" target="_blank"> Iran</a></td>
              </tr>
            </table>
            <br><b>Andere Ressourcen</b>
            <ul>
              <li><a href="https://ncov.dxy.cn/" target="_blank"> Dingxiangyuan</a></li> (Update national daily data and educate Coronavirus knowledge)
              <li><a href="http://zhongxinzhiyuan.cn/yiqing_real_time_map.html" target="_blank"> Zhongxinzhiyuan</a></li> (Update the latest news and data visualization)
              <li><a href="http://2019ncov.nosugartech.com/search.html" target="_blank"> Tongchengchaxun</a></li> (Coronavirus confirmed patients' trips query tool)
              <li><a href="https://voice.baidu.com/act/newpneumonia/newpneumonia" target="_blank"> Baidu Coronavirus Data Report</a></li> (Update Global daily data and hot topics about Coronavirus)
              <li><a href="https://www.nejm.org/coronavirus" target="_blank"> The New England Journal of Medicine</a></li> (A collection of articles and other resources on the Coronavirus (Covid-19) outbreak, including clinical reports, management
              guidelines, and commentary)
              <li><a href="http://www.nhc.gov.cn/xcs/pfzs/list_gzbd.shtml" target="_blank"> National Health Commission of the People's Republic of China </a></li> (Coronavirus(Covid-19) legal knowledge)
            </ul>
            </p>
          </div>
        </div>
      </div>
    </div>
  </div>
  <!-- <script src="js/main.js"></script> -->
  <script>




///////////////////////////////accessary//////////////////////////////////

$(window).ready(function() {
  $('.loader').fadeOut("slow");
});


var d3locale = d3.formatDefaultLocale({
    "thousands": ",",
    "grouping": [3],
});

L.TopoJSON = L.GeoJSON.extend({
  addData: function(jsonData) {
    if (jsonData.type === 'Topology') {
      for (key in jsonData.objects) {
        geojson = topojson.feature(jsonData, jsonData.objects[key]);
        L.GeoJSON.prototype.addData.call(this, geojson);
      }
    } else {
      L.GeoJSON.prototype.addData.call(this, jsonData);
    }
  }
});
// Copyright (c) 2013 Ryan Clark

// var createLabelIcon = function(labelClass, labelText) {
//   return L.divIcon({
//     className: labelClass,
//     html: labelText
//   })
// }
//


var worldBounds = L.latLngBounds(
  L.latLng(-60, -100), //Southwest
  L.latLng(80, 15) //Northeast
);


//totalConfirmed
function tc(country) {
  if (country == undefined) {
    country = 0
  } else {
    country = +country.split("-")[0];
  }
  return country;
}

//totalRecovered
function tr(country) {
  if (country.split("-")[2] == undefined) {
    country = 0
  } else {
    country = +country.split("-")[2];
  }
  return country;
}

//totalDeath
function td(country) {
  if (country.split("-")[3] == undefined) {
    country = 0
  } else {
    country = +country.split("-")[3];
  }
  return country;
}

//////////////////////////////////////////////////////////////////////////





    var mymap = L.map('map', {
      center: [38, -120],
      zoomControl: false,
      zoom: 4,
      maxZoom: 10,
      minZoom: 2,
      worldCopyJump: true
    }).fitBounds(worldBounds);
    // .fitWorld()
    new L.Control.Zoom({
      position: 'topright'
    }).addTo(mymap);



    var gray = L.tileLayer('https://{s}.basemaps.cartocdn.com/light_all/{z}/{x}/{y}@2x.png');
    // var dark = L.tileLayer('https://{s}.basemaps.cartocdn.com/dark_all/{z}/{x}/{y}@2x.png').addTo(mymap);
    var voyager =
      L.tileLayer('https://{s}.basemaps.cartocdn.com/rastertiles/voyager/{z}/{x}/{y}@2x.png').addTo(mymap);
    var satellite =
      L.tileLayer('https://server.arcgisonline.com/ArcGIS/rest/services/World_Imagery/MapServer/tile/{z}/{y}/{x}');

    var baseLayers = {
      'CARTO Light': gray,
      // 'Dark': dark,
      'CARTO Voyager': voyager,
      'ESRI Satellite': satellite
    }



    var historyChart, predictionChart;

    var colors = chroma.scale('YlOrRd').mode('lch').colors(6);
    for (i = 0; i < 6; i++) {
      $('head').append($("<style> .region-color-" + (i + 1).toString() + " { color: " + colors[i] + "; font-size: 15px; text-shadow: 0 0 3px #ffffff;} </style>"));
      $('head').append($("<style> .legend-color-" + (i + 1).toString() + " { background: " + colors[i] + "; font-size: 15px; text-shadow: 0 0 3px #ffffff;} </style>"));
    }



    Promise.all([
      // d3.csv('assets/whole_parsed_data.csv'), //datasets[0]
      d3.csv('assets/virus.csv'), //datasets[0]
      d3.json("assets/all-topo-15.json"), //datasets[1]
      d3.csv('assets/communities.csv'), //datasets[2]
      d3.csv('assets/timestamp.txt'), //datasets[3]
      d3.csv('assets/cases.csv'), //datasets[4]
      d3.csv('assets/united-states.txt'), //datasets[5]
      d3.csv('assets/canada-city.txt'), //datasets[6]
      d3.csv('assets/old-name.csv'), //datasets[7]
      d3.csv('assets/cases-canada.csv'), //datasets[8]
      d3.csv('assets/germany.txt') //datasets[9]
    ]).then(function(datasets) {

    
      $("#date").text(datasets[3][0].timestamp.split(".")[0]);

      var latest = datasets[0][datasets[0].length - 1];
      //delete latest["datetime"];

      var top = {},
        ustop = {},
        cntop = {},
        detop = {};
      top["china"] = 0;
      
      Object.keys(latest).forEach(function(d) {
        value = tc(datasets[0][datasets[0].length - 1][d]) - tr(datasets[0][datasets[0].length - 1][d]) - td(datasets[0][datasets[0].length - 1][d]);
        // value = tc(datasets[0][datasets[0].length - 1][d]);

         // check if value in latest can be found in the regional text file
        // if yes, add them to the respective object variable

        if (datasets[7]["columns"].includes(d)) {
          // China
          top["china"] += +value;
          cntop[d] = value;
        } else if (datasets[9]["columns"].includes(d)) {
          // Germany
          detop[d] = value;
        } else if (datasets[5]["columns"].includes(d)) {
          // US
          ustop[d] = value;
        } 
        else if (d != "datetime") {
          top[d] = value;
        } 

      })



      function sortJsObject(obj) {
        items = Object.keys(obj).map(function(key) {
          return [key, obj[key]];
        });
        items.sort(function(first, second) {
          return second[1] - first[1];
        });
        sorted_obj = {}
        $.each(items, function(k, v) {
          use_key = v[0]
          use_value = v[1]
          sorted_obj[use_key] = use_value
        })
        return (sorted_obj)
      }




      // sorted country values
      stop = sortJsObject(top);
      sustop = sortJsObject(ustop);
      sdetop = sortJsObject(detop);

      var places = {};

      function calPlace(name) {
        var place = {}
        place[name] = {
          't': ['t'],
          'c': ['Aggr. Confirmed'],
          's': ['s'],
          'r': ['Recovered'],
          'd': ['Death'],
          'a': ['Active Confirmed']
        }
        // cf = 0, sp = 0, rc = 0, dd = 0, active = 0;
        datasets[0].forEach(function(d) {
          var USTd = new Date(d["datetime"]);

          place[name].t.push(USTd.setHours(USTd.getHours() + 8));

          cf = 0, sp = 0, rc = 0, dd = 0, active = 0;
          current = d;
          delete current["datetime"];

          if (name == "Global Trend") {

            Object.values(current).forEach(function(d) {
              if (d == undefined) {
                d = "0"
              };
              items = d.split("-");
              switch (items.length) {
                case 4:
                  dd += +items[3];
                case 3:
                  rc += +items[2];
                case 2:
                  sp += +items[1];
                case 1:
                  cf += +items[0];
                  break;
              };
              active = cf - dd - rc;
            });

            // cf -= (tc(current["alabama"]) + tc(current["alaska"]) + tc(current["arizona"]) + tc(current["arkansas"]) + tc(current["california"]) + tc(current["colorado"]) + tc(current["connecticut"]) + tc(current["delaware"]) + tc(current[
            //     "florida"]) + tc(current["georgia usa"]) + tc(current["hawaii"]) + tc(current["idaho"]) + tc(current["illinois"]) + tc(current["indiana"]) + tc(current["iowa"]) + tc(current["kansas"]) + tc(current["kentucky"]) + tc(current[
            //     "louisiana"]) + tc(current["maine"]) + tc(current["maryland"]) + tc(current["massachusetts"]) + tc(current["michigan"]) + tc(current["minnesota"]) + tc(current["mississippi"]) + tc(current["missouri"]) + tc(current[
            //     "montana"]) + tc(
            //     current["nebraska"]) + tc(current["nevada"]) + tc(current["new hampshire"]) + tc(current["new jersey"]) + tc(current["new mexico"]) + tc(current["new york"]) + tc(current["north carolina"]) + tc(current["north dakota"]) +
            //   tc(current[
            //     "ohio"]) + tc(current["oklahoma"]) + tc(current["oregon"]) + tc(current["pennsylvania"]) + tc(current["rhode island"]) + tc(current["south carolina"]) + tc(current["south dakota"]) + tc(current["tennessee"]) + tc(current[
            //     "texas"]) +
            //   tc(current["utah"]) + tc(current["vermont"]) + tc(current["virginia"]) + tc(current["washington"]) + tc(current["west virginia"]) + tc(current["canada"]));

            // rc -= (tr(current["alabama"]) + tr(current["alaska"]) + tr(current["arizona"]) + tr(current["arkansas"]) + tr(current["california"]) + tr(current["colorado"]) + tr(current["connecticut"]) + tr(current["delaware"]) + tr(current[
            //     "florida"]) + tr(current["georgia usa"]) + tr(current["hawaii"]) + tr(current["idaho"]) + tr(current["illinois"]) + tr(current["indiana"]) + tr(current["iowa"]) + tr(current["kansas"]) + tr(current["kentucky"]) + tr(current[
            //     "louisiana"]) + tr(current["maine"]) + tr(current["maryland"]) + tr(current["massachusetts"]) + tr(current["michigan"]) + tr(current["minnesota"]) + tr(current["mississippi"]) + tr(current["missouri"]) + tr(current[
            //     "montana"]) + tc(
            //     current["nebraska"]) + tr(current["nevada"]) + tr(current["new hampshire"]) + tr(current["new jersey"]) + tr(current["new mexico"]) + tr(current["new york"]) + tr(current["north carolina"]) + tr(current["north dakota"]) +
            //   tr(current[
            //     "ohio"]) + tr(current["oklahoma"]) + tr(current["oregon"]) + tr(current["pennsylvania"]) + tr(current["rhode island"]) + tr(current["south carolina"]) + tr(current["south dakota"]) + tr(current["tennessee"]) + tr(current[
            //     "texas"]) +
            //   tr(current["utah"]) + tr(current["vermont"]) + tr(current["virginia"]) + tr(current["washington"]) + tr(current["west virginia"]) + tr(current["canada"]));

            // dd -= (td(current["alabama"]) + td(current["alaska"]) + td(current["arizona"]) + td(current["arkansas"]) + td(current["california"]) + td(current["colorado"]) + td(current["connecticut"]) + td(current["delaware"]) + td(current[
            //     "florida"]) + td(current["georgia usa"]) + td(current["hawaii"]) + td(current["idaho"]) + td(current["illinois"]) + td(current["indiana"]) + td(current["iowa"]) + td(current["kansas"]) + td(current["kentucky"]) + td(current[
            //     "louisiana"]) + td(current["maine"]) + td(current["maryland"]) + td(current["massachusetts"]) + td(current["michigan"]) + td(current["minnesota"]) + td(current["mississippi"]) + td(current["missouri"]) + td(current[
            //     "montana"]) + tc(
            //     current["nebraska"]) + td(current["nevada"]) + td(current["new hampshire"]) + td(current["new jersey"]) + td(current["new mexico"]) + td(current["new york"]) + td(current["north carolina"]) + td(current["north dakota"]) +
            //   td(current[
            //     "ohio"]) + td(current["oklahoma"]) + td(current["oregon"]) + td(current["pennsylvania"]) + td(current["rhode island"]) + td(current["south carolina"]) + td(current["south dakota"]) + td(current["tennessee"]) + td(current[
            //     "texas"]) +
            //   td(current["utah"]) + td(current["vermont"]) + td(current["virginia"]) + td(current["washington"]) + td(current["west virginia"]) + td(current["canada"]));

          } else if (name == "china") {


            // for (const [key, value] of Object.entries(current)) {

            //   if (key == "anhui" || key == "beijing" || key == "chongqing" || key == "fujian" || key == "gansu" || key == "guangdong" ||
            //     key == "guangxi" || key == "guizhou" || key == "hainan" || key == "hebei" || key == "heilongjiang" || key == "henan" || key == "hongkong" ||
            //     key == "hubei" || key == "hunan" || key == "neimenggu" || key == "jiangsu" || key == "jiangxi" || key == "jilin" || key == "liaoning" ||
            //     key == "macau" || key == "ningxia" || key == "qinghai" || key == "shaanxi" || key == "shandong" || key == "shanghai" || key == "shanxi" ||
            //     key == "sichuan" || key == "taiwan" || key == "tianjin" || key == "xinjiang" || key == "yunnan" || key == "zhejiang" || key == "xizang") {

            //     if (value == undefined) {
            //       value = "0"
            //     };
            //     items = value.split("-");
            //     switch (items.length) {
            //       case 4:
            //         dd += +items[3];
            //       case 3:
            //         rc += +items[2];
            //       case 2:
            //         sp += +items[1];
            //       case 1:
            //         cf += +items[0];
            //         break;
            //     };
            //     active = cf - dd - rc;
            //   }
            // }


          } else {


            d = current[name];
            if (d == undefined) {
              d = "0"
            };
            items = d.split("-");
            switch (items.length) {
              case 4:
                dd += +items[3];
              case 3:
                rc += +items[2];
              case 2:
                sp += +items[1];
              case 1:
                cf += +items[0];
                break;
            };
            active = cf - dd - rc;

          }
          active = cf - dd - rc;
          place[name].c.push(cf);
          //place[name].s.push(sp);
          place[name].r.push(rc);
          place[name].d.push(dd);
          place[name].a.push(active);

        });

        return place[name];
      }

      function showPlace(name) {

        len = places[name].t.length;
        $(".confirmed-count").text(places[name].c[len - 1].toLocaleString());
        $(".recovered-count").text(places[name].r[len - 1].toLocaleString());
        $(".death-count").text(places[name].d[len - 1].toLocaleString());
        $(".active-count").text(places[name].a[len - 1].toLocaleString());

        nc = places[name].c[len - 1] - places[name].c[len - 2];
        nr = places[name].r[len - 1] - places[name].r[len - 2];
        nd = places[name].d[len - 1] - places[name].d[len - 2];
        na = places[name].a[len - 1] - places[name].a[len - 2];

        if (nc > 0) {
          $(".confirmed-new-count").text("+" + nc.toLocaleString());
        } else if (nc == 0) {
          $(".confirmed-new-count").text("");
        } else {

          $(".confirmed-new-count").text(nc.toLocaleString());
        }

        if (nr > 0) {
          $(".recovered-new-count").text("+" + nr.toLocaleString());
        } else if (nr == 0) {
          $(".recovered-new-count").text("")
        } else {
          $(".recovered-new-count").text(nr.toLocaleString());
        }
        if (nd > 0) {
          $(".death-new-count").text("+" + nd.toLocaleString());
        } else if (nd == 0) {
          $(".death-new-count").text("")
        } else {
          $(".death-new-count").text(nd.toLocaleString());
        }


        if (na > 0) {
          document.getElementById("counticon").style.display = "initial";
          $(".active-new-count").text("+" + na.toLocaleString());
        } else if (na < 0) {
          document.getElementById("counticon").style.display = "initial";
          $(".active-new-count").text("" + na.toLocaleString());
        } else if (na == 0) {
          document.getElementById("counticon").style.display = "none";
          $(".active-new-count").text("")
        } else {
          document.getElementById("counticon").style.display = "none";
          $(".active-new-count").text(na.toLocaleString());
        }


        // Set place name 
        $("#placename").text(name.toUpperCase());
   
        // Set website source
        $("#source-website").html('.....');
        
      }


      function setFill(enname) {
        var pop = datasets[0][datasets[0].length - 1][enname];
        if (pop == "" || pop == undefined || pop.toString().split("-")[0] == "0") {
          return 'url(img/texture-s.png)'; //non-case country, 0 aggregate confirm
        } else {
          pop = +pop.toString().split("-")[0] - +pop.toString().split("-")[2] - +pop.toString().split("-")[3]; // remaining confirmed
          // return "#00000000";
        }
        if (pop == 0) {
          return 'url(img/texture-sg.png)'; // 0 active confirm
          // return 'url("data:image/svg+xml;base64,PHN2ZyB4bWxucz0naHR0cDovL3d3dy53My5vcmcvMjAwMC9zdmcnIHdpZHRoPScxMCcgaGVpZ2h0PScxMCc+CiAgPHJlY3Qgd2lkdGg9JzEwJyBoZWlnaHQ9JzEwJyBmaWxsPSd3aGl0ZScgLz4KICA8cmVjdCB4PScwJyB5PScwJyB3aWR0aD0nMScgaGVpZ2h0PScxJyBmaWxsPSdibGFjaycgLz4KPC9zdmc+")';
        } else {
          return 'url()';
        }


      }

      function setColor(enname) {
        var id = 0;
        var pop = datasets[0][datasets[0].length - 1][enname];

        if (pop != undefined) {
          pop = +pop.toString().split("-")[0] - +pop.toString().split("-")[2] - +pop.toString().split("-")[3]; // remaining confirmed
        } else {
          pop = 0;
          // return "#00000000";
        }

        if (pop >= 10000) {
          id = 5;
        } else if (pop > 1000 && pop <= 10000) {
          id = 4;
        } else if (pop > 250 && pop <= 1000) {
          id = 3;
        } else if (pop > 100 && pop <= 250) {
          id = 2;
        } else if (pop > 10 && pop <= 100) {
          id = 1;
        } else if (pop > 0 && pop <= 10) {
          id = 0;
        } else {
          id = -1;
          return "#00000000";
        }

        return colors[id];

      }


      function style(feature) {
        if (feature.properties.enname == "us" || feature.properties.enname == "canada") {
          return {
            fillOpacity: 0,
            opacity: 0,
          };
        } else {
          return {
            fill: setFill(feature.properties.enname),
            fillColor: setColor(feature.properties.enname),
            fillOpacity: 0.4,
            weight: 0.5,
            opacity: 1,
            color: '#b4b4b4',
            dashArray: '2'
          };
        }
      }



      function highlightFeature(e) {
        // e indicates the current event
        var layer = e.target; //the target capture the object which the event associates with
        layer.setStyle({
          weight: 2,
          opacity: 0.8,
          color: '#e3e3e3',
          fillColor: '#00ffd9',
          fillOpacity: 0.1
        });
        // bring the layer to the front.
        layer.bringToFront();
        if (e.target.feature.properties.enname == "us" || e.target.feature.properties.enname == "canada") {
          layer.bringToBack();
        }
      }

      // 3.2.2 zoom to the highlighted feature when the mouse is clicking onto it.
      function zoomToFeature(e) {
        // mymap.fitBounds(e.target.getBounds());
        L.DomEvent.stopPropagation(e);
        $("#hint").text("Click here to the global trend.");
        displayPlace(e.target.feature.properties.enname)
      }

      // 3.2.3 reset the hightlighted feature when the mouse is out of its region.
      function resetHighlight(e) {
        areas.resetStyle(e.target);

      }

      // 3.3 add these event the layer obejct.
      function onEachFeature(feature, layer) {
        layer.on({
          mouseover: highlightFeature,
          click: zoomToFeature,
          mouseout: resetHighlight
        });
      }

      var areas = new L.TopoJSON(datasets[1], {
        style: style,
        onEachFeature: onEachFeature
      }).addTo(mymap);


      new L.control.layers(baseLayers, {
        "Infection Level": areas,
      }, {
        collapsed: false
      }).addTo(mymap);


      $("#hint").on("click", function() {
        places["Global Trend"] = calPlace("Global Trend");
        showPlace("Global Trend");
        // calCounts(global);
        historyChart.load({
          columns: [places["Global Trend"].c, places["Global Trend"].a, places["Global Trend"].r, places["Global Trend"].d],
          unload: ['Aggr. Confirmed', 'Active Confirmed', 'Recovered', 'Death'],
        });
        predictionChart.load({
          columns:[],
          unload:[]
        })

        $("#hint").text("Click a place to review local trend.");

      });

      mymap.on('click', onMapClick);


      function onMapClick(e) {
        $("#hint").click();
      }


      places["Global Trend"] = calPlace("Global Trend");
      showPlace("Global Trend");


      // Global trend line chart
      historyChart = c3.generate({
        size: {
          height: 350,
          width: 460
        },
        data: {
          x: "t",
          y: "confirmed",
          columns: [places["Global Trend"].t, places["Global Trend"].c, places["Global Trend"].a, places["Global Trend"].r, places["Global Trend"].d],
          type: 'line',
          axes: {
            confirmed: 'y'
          },
          colors: {
            'Aggr. Confirmed': '#dc3545',
            // Suspected: 'orange',
            'Active Confirmed': 'orange',
            Recovered: '#28a745',
            Death: 'SlateBlue'
          }
        },
        zoom: {
          enabled: true
        },
        axis: {
          x: {
            type: "timeseries",
            tick: {
              format: "%b %d",
              centered: true,
              fit: true,
              count: 8
            }
          },
          y: {
            label: {
              text: 'Cases',
              position: 'outer-middle'
            },
            min: 0,
            padding: {
              bottom: 0
            },
            tick: {
              format: d3locale.format(",")
            },
            type: 'linear'
          }
        },
        point: {
          r: 3,
          focus: {
            expand: {
              r: 5
            }
          }
        },
        zoom: {
          // rescale: true,
          enabled: false,
          type: "scroll",
        },
        tooltip: {
          linked: true,
        },
        legend: {
          position: 'inset',
          inset: {
            anchor: "top-left",
            y: 10
          },
        },
        bindto: "#total-chart"
      });


      // Global trend line chart
      predictionChart = c3.generate({
        size: {
          height: 350,
          width: 460
        },
        data: {
          x: "x",
          columns: [],
          colors: {
            'confirmed': '#dc3545',
            'active':'orange',
            'recovered': '#28a745',
            'dead': 'SlateBlue',
            'confirmed_pred': '#e38c94',
            'active_pred':'#f7d088',
            'recovered_pred': '#28a745',
            'dead_pred': '#74b974',
          },
          
        },
        point: {
            show: false
          },
          axis: {
        x: {
            type: 'timeseries',
            tick: {
              fit: true,
                format: '%b %d',
                count: 8,

            }
        },
          y: {
            label: {
              text: 'Cases',
              position: 'outer-middle'
            },
            min: 0,
            padding: {
              bottom: 0
            },
            tick: {
              format: d3locale.format(",")
            },
            type: 'linear'
          }
    },
        tooltip: {
          linked: true,
        },
        point: {
          r: 1,
          focus: {
            expand: {
              r: 3
            }
          }
        },
        legend: {
          position: 'inset',
          inset: {
            anchor: "top-left",
            y: 10
          },
        },

        bindto: "#prediction-chart"
      });

      function displayPlace(name) {

        places[name] = calPlace(name);
        showPlace(name);

        historyChart.load({
          columns: [places[name].c, places[name].a, places[name].r, places[name].d],
          unload: ['Aggr. Confirmed', 'Active Confirmed', 'Recovered', 'Death'],
        });
      
        fetch(`/predictions/${name}`) // Call the fetch function passing the url of the API as a parameter
        .then((resp) => resp.json()) // Transform the data into json
        .then(function(data) {
            predictionChart.load({columns:data.data})
          })
            .catch(function() {
              console.log('Downoad of prediction data failed')
        })

      }


      function makeTable() {

        var topinuse = {};
        if (document.getElementById('areaSwitcher').checked != false) {
          topinuse = sdetop;
        } else {
          topinuse = stop;
        }

        Object.keys(topinuse).slice(0, 51).forEach(function(d) {
          if (d.toUpperCase() == "DIAMOND PRINCESS") {
            return;
          }
          var dlabel = d.toUpperCase();
          if (d.toUpperCase() == "GEORGIA USA") {
            dlabel = "GEORGIA";
          }
          $("tbody").append("<tr id='" + d.replace(" ", "") + "-row'><th style='text-align:right;cursor: pointer;'>" + dlabel + "</th></tr>");
          places[d] = calPlace(d);


          $("tr#" + d.replace(" ", "") + "-row").append('<th style="text-align:right"><i class="cell-' + d.replace(" ", "") + '-aggre-confirmed">' + places[d].c[len - 1].toLocaleString() + '</i></th>');


          $("tr#" + d.replace(" ", "") + "-row").append('<th ><i class="cell-' + d.replace(" ", "") + '">' + "" + '</i></th>');


          var a = [];
          for (var i = len - showLen; i < len; i++) {
            a.push(places[d].a[i]);
          }

          $("." + 'cell-' + d.replace(" ", "")).sparkline(a, {
            type: 'line',
            lineColor: '#bf0000',
            fillColor: '#ffd4aa',
            disableTooltips: true
          });



          for (var i = len - showLen; i < len; i++) {
            // a.push(places[d].a[i]);
            //$("tr#" + d.replace(" ", "") + "-row").append('<th scope="col"><i class="cell">' + places[d].c[i] + '</i></th>');
            $("tr#" + d.replace(" ", "") + "-row").append('<th ><i class="cell cell-' + d.replace(" ", "") + '-' + i.toString() + '">' + "" + '</i></th>');
            bgcolor = "#28a745";
            bdcolor = "#28a745";
            size = "32px";
            bdsize = "0px";
            top = "0rem";
            left = "0rem";


            //all the cases are recovered
            // c ===> 0, 10, 100, 1000, 10000
            // size =>0,  4,   8,   16,    32

            if (places[d].c[i] >= 10000) {
              size = "32px"
              top = "-.45rem";
              left = "-.35rem";


            } else if (places[d].c[i] < 10000 && places[d].c[i] >= 1000) {
              size = "24px";
              top = "-.2rem";
              left = "-.1rem";

            } else if (places[d].c[i] < 1000 && places[d].c[i] >= 100) {
              size = "16px";
              top = "0rem";
              left = ".1rem";;


            } else if (places[d].c[i] < 100 && places[d].c[i] >= 10) {
              size = "10px";
              top = ".25rem";
              left = ".25rem";

            } else if (places[d].c[i] < 10 && places[d].c[i] >= 1) {
              size = "8px";
              top = ".25rem";
              left = ".25rem";
            } else {
              size = "0px";
              bdsize = "0px";
            }


            // a/c rate ==> red, oregen, yellow, green{plus yellow}
            // color ==>  recover:  #28a745
            // a ===>
            acrate = places[d].a[i] / places[d].c[i]

            colors = chroma.scale('YlOrRd').mode('lch').colors(6);
            if (acrate > 0.995) {
              bgcolor = colors[5];
            } else if (acrate >= 0.9 && acrate <= 0.995) {
              bgcolor = colors[4];
            } else if (acrate >= 0.5 && acrate <= 0.9) {
              bgcolor = colors[3];
            } else if (acrate >= 0.3 && acrate <= 0.5) {
              bgcolor = colors[2];
            } else if (acrate >= 0.2 && acrate <= 0.3) {
              bgcolor = colors[1];
            } else if (acrate < 0.2 && places[d].c[i] > 100) {
              bgcolor = '#28a745';
            } else {
              bgcolor = colors[1];

            }

            $('.cell-' + d.replace(" ", "") + '-' + i.toString())
              .css("background-color", bgcolor)
              .css("border", bdsize + " solid " + bdcolor)
              .css("width", size)
              .css("height", size)
              .css("margin-top", top)
              .css("margin-left", left);


          }




          $("tr#" + d.replace(" ", "") + "-row").on("click", function() {
            // places[d] = calPlace(d);
            showPlace(d);

            historyChart.load({
              columns: [places[d].c, places[d].a, places[d].r, places[d].d],
              unload: ['Aggr. Confirmed', 'Active Confirmed', 'Recovered', 'Death'],
            });
            predictionChart.load({
              columns: [places[d].c, places[d].a, places[d].r, places[d].d],
              unload: ['Aggr. Confirmed', 'Active Confirmed', 'Recovered', 'Death'],
            });
          })



        })

      }


      $('#areaSwitcher').change(function() {

        $('.loader').show();

        $("#rankingToggle").css('visibility', 'visible');
        $("#table").css("visibility", "visible");
        $(".leaflet-control-container").css("visibility", "hidden");


        len = places["Global Trend"].t.length
        showLen = 25
        $("thead").html('<th scope="col" style="text-align:right; width:120px !important"><b>Country/State</b></th>');
        $("thead").append("<th style='text-align:center' >Aggr. Cfm </th>");
        $("thead").append("<th style='text-align:center' >Active Cfm. Trend</th>");


        Object.values(places["Global Trend"].t.slice(len - 1 - showLen, len - 1)).forEach(function(d) {
          //label = new Date(new Date(d).setHours(new Date(d).getHours() + 8)).toString().substring(4,10);
          label = (new Date(d)).toString().substring(4, 10);
          // console.log(label);
          $("thead").append("<th style='text-align:center' >" + label + "</th>");
        });


        $("tbody").html('');
        makeTable();


        $('.loader').fadeOut("slow");

      })


      $('#panelSwitcher').change(function() {
        $('.loader').show();

        if (document.getElementById('panelSwitcher').checked == false) {
          $("#table").css("visibility", "hidden");

          $("#rankingToggle").css("visibility", "hidden");
          $(".leaflet-control-container").css("visibility", "visible");
          $("#content-explain").text(
            "In the main map, an country or region's inflection level is measured by the # of today's active/remaining confirmed cases. The gray slash texture indicates no previous cases are discovered; the greentexture means the region in which all the infected cases have recovered."
          );
          $("thead").html('');
          $("tbody").html('');


        } else {

          $("#rankingToggle").css('visibility', 'visible');
          $("#content-explain").text(
            "This situational heatmap illustrates the rank of active confirmed cases in all countries or U.S. states in the descending order. It uses a series of blocks in different size and color to represent the number and recover rate of coronavirus cases of different places within the last 20 days. The size of the block increases as the number aggregated confirmed cases increase. While the color of the block, in a \"yellow-orange-red\" ramp, gets darker as the 'active / aggregate' confirmed rate increases."
          );
          $("#table").css("visibility", "visible");
          $(".leaflet-control-container").css("visibility", "hidden");

          $("#rankingText").remove();
          $("#rankingIcon").remove();
          $("#rankingSpace").remove();



          len = places["Global Trend"].t.length
          showLen = 20
          $("thead").html('<th scope="col" style="text-align:right; width:120px !important"><b>Country</b></th>');

          $("thead").append("<th style='text-align:center' >Aggr. Cfm </th>");
          $("thead").append("<th style='text-align:center' >Active Cfm. Trend</th>");

          Object.values(places["Global Trend"].t.slice(len - 1 - showLen, len - 1)).forEach(function(d) {
            //label = new Date(new Date(d).setHours(new Date(d).getHours() + 8)).toString().substring(4,10);
            label = (new Date(d)).toString().substring(4, 10);
            // console.log(label);
            $("thead").append("<th style='text-align:center' >" + label + "</th>");
          });


          $("tbody").html('');


          makeTable();


        }
        $('.loader').fadeOut("slow");

      })

      $(".leaflet-control-attribution")
        .css("background-color", "transparent")
        .html("");



    });
  </script>

</body>

</html>

